
const settings = new Settings();

settings.engine.preload = true; // FIXME: usually 'true' for final product, but 'false' is useful for development
settings.demo.renderer.sortObjects = true;
settings.demo.renderer.logarithmicDepthBuffer = false;
settings.demo.sync.rocketFile = 'sync/demo.rocket';
settings.demo.sync.beatsPerMinute = 100;
settings.demo.sync.rowsPerBeat = 8;
settings.demo.camera.near = 0.1;
settings.demo.camera.far = 1000.0;
settings.engine.tool = false;
//settings.demo.clearColor = { r: 1.0, g: 1.0, b: 1.0, a: 1.0 };
settings.demo.model.shape.material.type = 'Standard';
settings.demo.shadow.mapSize.width = 2048;
settings.demo.shadow.mapSize.height = settings.demo.shadow.mapSize.width;
settings.demo.image.texture.minFilter = 'NearestFilter';
settings.demo.image.texture.magFilter = 'NearestFilter';
//settings.demo.image.texture.wrapS = 'RepeatWrapping';
//settings.demo.image.texture.wrapT = 'RepeatWrapping';
settings.demo.fbo.color.texture.minFilter = 'NearestFilter';
settings.demo.fbo.color.texture.magFilter = 'NearestFilter';
//settings.demo.fbo.color.texture.wrapS = 'RepeatWrapping';
//settings.demo.fbo.color.texture.wrapT = 'RepeatWrapping';
settings.engine.fps = 60;

const deg2rad = 0.01745329251;
window.camPos = [0.0, 0.0, 0.0];
window.camPosLength = 1.0;
window.camFov = 0.0;
window.beat =  60/100;
window.tick = window.beat / 8;
window.pattern = window.beat * 6;
window.camNear = 0.0;
window.camFar = 0.0;
window.globalTime = 0.0;

window.endpattern = (60 / 145) * 8;
includeFile('multiSceneEffects/PostProcess.js');
includeFile('multiSceneEffects/dof.js');
includeFile('multiSceneEffects/effectStarfield.js');
includeFile('multiSceneEffects/EffectExplosion.js');
includeFile('scenes/intro/intro.js');

includeFile('multiSceneEffects/shaderInjections.js');

Demo.prototype.AddText = function (myText, posX, posY, textSync) {


      this.loader.addAnimation([{
      visible: ()=> Sync.get(textSync) > 0.01, 
      text:{ string:myText, name:"multiSceneEffects/VT323-Regular.ttf"},
      perspective:"2d", 
      color:[{"r":0.0,"g":0.0,"b":0.0}],
      position:[{x:posX-.005, y:()=> -.01+Math.sin(5*getSceneTimeFromStart())*.02+posY}],
      scale: [{ x: 3.0, y: 3.0 }],
      
  }]);

    this.loader.addAnimation([{
      visible: ()=> Sync.get(textSync) > 0.01, 
      text:{ string:myText, name:"multiSceneEffects/VT323-Regular.ttf"},
      perspective:"2d", 
      color:[{"r":1.0,"g":1.0,"b":1.0}],
      position:[{z:-1, x:posX, y:()=> Math.sin(5*getSceneTimeFromStart())*.02+posY}],
      scale: [{ x: 3.0, y: 3.0 }],
    "material": {

      "transparent": true,
      "depthWrite": true,

    },
  }]);

}
Demo.prototype.cameraSetup = function (stopCamAt) {
    this.loader.addAnimation({
        "camera": "cam1"
        , "position": [{ "x": 0, "y": 0, "z": 10 }]
        , "lookAt": [{ "x": 0.0, "y": 0.0, "z": 0.0 }]
        , "up": [{ "x": 0, "y": 1, "z": 0 }]
        , "perspective": [{ "fov": 75, "aspect": 16 / 9, "near": .05, "far": 1000 }]
        , "distYawPitch": [-5.0, 1, 2.0]
        , "instableTimer": [0.0, 0.0, 0.0, 0.0, 0.0]
        , "runPreFunction": (animation) => {
            for (let i = 0; i < animation.instableTimer.length; i++) {
                animation.instableTimer[i] += Math.random() * getDeltaTime();
            }
            let distance = .05 * Sync.get('Cam:Instability') * Math.sin(2 * animation.instableTimer[3]) + Sync.get('Cam:Distance');
            let pitch = (Sync.get('Cam:Instability') * 5 * Math.cos(2 * animation.instableTimer[1]) + Sync.get('Cam:Yaw')) * deg2rad;
            let roll = (Sync.get('Cam:Instability') * 5 * Math.sin(2 * animation.instableTimer[2]) + Sync.get('Cam:Pitch')) * deg2rad;
            let yaw = 0.0;
            let target = [Sync.get('Cam:TargetX'), Sync.get('Cam:TargetY'), Sync.get('Cam:TargetZ')];
            let points = [0, 0, distance];
            let cosa = Math.cos(yaw),
                sina = Math.sin(yaw);
            let cosb = Math.cos(pitch),
                sinb = Math.sin(pitch);
            let cosc = Math.cos(roll),
                sinc = Math.sin(roll);
            let Axx = cosa * cosb,
                Axy = cosa * sinb * sinc - sina * cosc,
                Axz = cosa * sinb * cosc + sina * sinc;
            let Ayx = sina * cosb,
                Ayy = sina * sinb * sinc + cosa * cosc,
                Ayz = sina * sinb * cosc - cosa * sinc;
            let Azx = -sinb,
                Azy = cosb * sinc,
                Azz = cosb * cosc;
            let px = points[0];
            let py = points[1];
            let pz = points[2];
            let newPoints = [
                (Axx * px + Axy * py + Axz * pz) + target[0],
                Ayx * px + Ayy * py + Ayz * pz + target[1],
                Azx * px + Azy * py + Azz * pz + target[2]
            ];
            window.camPos = newPoints;
            window.camPosLength = Math.sqrt(newPoints[0] * newPoints[0] + newPoints[1] * newPoints[1] + newPoints[2] * newPoints[2]);
            animation.position[0].x = newPoints[0];
            animation.position[0].y = newPoints[1];
            animation.position[0].z = newPoints[2];
            animation.lookAt[0].x = Sync.get('Cam:Instability') * .25 * Math.sin(2 * animation.instableTimer[3]) + Sync.get('Cam:TargetX');
            animation.lookAt[0].y = Sync.get('Cam:Instability') * .25 * Math.cos(2 * animation.instableTimer[4]) + Sync.get('Cam:TargetY');
            animation.lookAt[0].z = Sync.get('Cam:TargetZ');
            animation.perspective[0].fov = Sync.get('Cam:FOV');
            window.camNear = animation.perspective[0].near;
            window.camFar = animation.perspective[0].far;
            window.camFov = animation.perspective[0].fov * deg2rad;

            let camRoll = Sync.get('Cam:Roll') * deg2rad;
            animation.up[0].x = -Math.sin(camRoll);
            animation.up[0].y = Math.cos(camRoll);
            animation.up[0].z = 0;

        }
    });


};

Demo.prototype.setScene = function (sceneName) {
    this.loader.setScene(sceneName);
    this.cameraSetup();
};

Demo.prototype.init = function () {
    const bpm = settings.demo.sync.beatsPerMinute;
    const beat = 60 / bpm;

    this.sceneIntro();


    this.loader.setScene('main');

    const scenes = [
        // intro
        { start: 0, duration: 32.5 * window.pattern + 16 * window.endpattern, name: 'intro', dof: true, prePostProcessing: false },
    ];

    scenes.forEach((scene) => {
        this.loader.addAnimation({ start: scene.start, duration: scene.duration, scene: { name: scene.name, fbo: { name: scene.name + 'Fbo' } }, ...(scene.parameters || {}) });
    });


    this.loader.addAnimation({ fbo: { name: 'screenDof', action: 'begin', storeDepth: false } });
    scenes.forEach((scene) => {
        if (scene.dof) {
            this.loader.addAnimation({
                start: scene.start, duration: scene.duration, color: scene.color, image: [scene.name + 'Fbo.depth.fbo', scene.name + 'Fbo.color.fbo'],
                material: { blending: 'CustomBlending', blendEquation: 'MaxEquation', blendSrc: 'SrcColorFactor', blendDst: 'SrcColorFactor' },
                shader: { name: 'multiSceneEffects/depthToColor.fs' }
            });
        }
    });



    this.loader.addAnimation({ fbo: { name: 'screenDof', action: 'unbind' } });

    this.loader.addAnimation({ fbo: { name: 'screenFbo', action: 'begin', storeDepth: false } });
    scenes.forEach((scene) => {
        if (scene.dof) {
            this.loader.addAnimation({ start: scene.start, duration: scene.duration, color: scene.color, image: scene.name + 'Fbo.color.fbo', additive: scene.additive ?? false });
        }
    });
    this.loader.addAnimation({ fbo: { name: 'screenFbo', action: 'unbind' } });

    this.loader.addAnimation({ fbo: { name: 'blur', action: 'begin', storeDepth: false } });
    this.loader.addAnimation({
        image: 'screenFbo.color.fbo',
        shader: {
            name: 'multiSceneEffects/gaussianBlur.fs',
            variable: [
                { "name": "directions", "value": [16.0] },
                { "name": "quality", "value": [4.0] }, // 4
                { "name": "size", "value": [16.0] } // 16
            ]
        }
    });
    this.loader.addAnimation({ fbo: { name: 'blur', action: 'unbind' } });

    this.loader.addAnimation({ fbo: { name: 'postProcessableFbo', action: 'begin', storeDepth: false } });
    this.loader.addAnimation({
        image: ['screenFbo.color.fbo', 'blur.color.fbo', 'screenDof.color.fbo'],
        shader: {
            name: 'multiSceneEffects/dof.fs',
            variable: [
                { "name": "dofCenter", "value": [() => Sync.get('General:dofCenter')] },
                { "name": "dofWidth", "value": [() => Sync.get('General:dofWidth')] }
            ]
        }
    });



    scenes.forEach((scene) => {
        if (!scene.dof) {
            this.loader.addAnimation({ start: scene.start, duration: scene.duration, color: scene.color, image: scene.name + 'Fbo.color.fbo', additive: scene.additive ?? false });
        }
    });

    this.loader.addAnimation({ fbo: { name: 'postProcessableFbo', action: 'unbind' } });

    this.addPostProcess('postProcessableFbo.color.fbo');
    /*
      this.loader.addAnimation({
        image: 'screenDof.color.fbo'
      });
    */
    this.loader.addAnimation({
        image: '_embedded/defaultTransparent.png',
        shader: {
            name: 'multiSceneEffects/vignette.fs',
            variable: [
                { "name": "vignetteStrength", "value": [() => Sync.get('PostProc:VignetteStrength')] }
            ]
        }
    });
    // intro scanline uuuuglyyy
    this.loader.addAnimation({
        image: 'img/scan.png',
        transparent: true,
        perspective: '2d',
        scale: [{ uniform2d: 1 }],
        color: [{
            r: 255, g: 255, b: 255, a: () => Sync.get('Vitru:ScanAlpha')
        }],
        visible: () => Sync.get('Vitru:ScanAlpha') > 0.01,
        material: { blending: 'CustomBlending' }
    });  


};
